'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.clean = exports.push = exports.pull = undefined;

var _vault = require('./task/vault');

var vault = _interopRequireWildcard(_vault);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function pull(_ref) {
    var _ref$host = _ref.host;
    var host = _ref$host === undefined ? 'localhost' : _ref$host;
    var _ref$port = _ref.port;
    var port = _ref$port === undefined ? '4502' : _ref$port;
    var _ref$user = _ref.user;
    var user = _ref$user === undefined ? 'admin' : _ref$user;
    var _ref$pass = _ref.pass;
    var pass = _ref$pass === undefined ? 'admin' : _ref$pass;
    var _ref$source = _ref.source;
    var source = _ref$source === undefined ? undefined : _ref$source;
    var _ref$dest = _ref.dest;
    var dest = _ref$dest === undefined ? undefined : _ref$dest;

    if (!source || !dest) {
        throw new Error('Please specify source and/or dest');
    }

    return new Promise(function (resolve, reject) {
        vault.pull({
            host: host,
            port: port,
            user: user,
            pass: pass,
            dest: dest,
            source: source
        }, function (err, stdout, stderr) {
            if (err) {
                reject(err, stdout, stderr);
            }

            resolve(stdout);
        });
    });
}

function push(_ref2) {
    var _ref2$host = _ref2.host;
    var host = _ref2$host === undefined ? 'localhost' : _ref2$host;
    var _ref2$port = _ref2.port;
    var port = _ref2$port === undefined ? '4502' : _ref2$port;
    var _ref2$user = _ref2.user;
    var user = _ref2$user === undefined ? 'admin' : _ref2$user;
    var _ref2$pass = _ref2.pass;
    var pass = _ref2$pass === undefined ? 'admin' : _ref2$pass;
    var _ref2$dest = _ref2.dest;
    var dest = _ref2$dest === undefined ? '/' : _ref2$dest;
    var _ref2$source = _ref2.source;
    var source = _ref2$source === undefined ? undefined : _ref2$source;

    if (!source) {
        throw new Error('Please specify source');
    }

    return new Promise(function (resolve, reject) {
        vault.push({
            host: host,
            port: port,
            user: user,
            pass: pass,
            dest: dest,
            source: source
        }, function (err, stdout, stderr) {
            if (err) {
                reject(err, stdout, stderr);
            }

            resolve(stdout);
        });
    });
}

function clean(path) {
    if (!path) {
        throw new Error('Please specify path to clean');
    }
    return new Promise(function (resolve, reject) {
        vault.clean(path, function (err, stdout, stderr) {
            if (err) {
                reject(err, stdout, stderr);
            }

            resolve(stdout);
        });
    });
}

exports.pull = pull;
exports.push = push;
exports.clean = clean;