'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.pull = pull;

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _child_process = require('child_process');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var baseDir = _path2.default.join(__dirname, '../..');
var Progress = require('node-progress').get();
var wait = new Progress();

function pull(options, cb) {
    var env = 'http://' + options.host + ':' + options.port + '/crx';
    var destination = _path2.default.join(process.cwd(), options.dest);
    var sitePath = _path2.default.join('/', options.source);

    console.log(_chalk2.default.cyan('Pulling content from ' + sitePath + ' down to ' + destination));
    console.log(_chalk2.default.red('This may take a bit of time...'));
    wait.start();

    (0, _child_process.execFile)(_path2.default.join(baseDir, 'bin/vlt'), ['-v', '--credentials', options.user + ':' + options.pass, 'export', env, sitePath, destination], function (err, stdout, stderr) {
        if (err) {
            throw err;
        }

        wait.finish();
        console.log(stdout);
        console.log(_chalk2.default.cyan('Finished pulling content from ' + sitePath + ' to ' + destination));

        if (cb && typeof cb === 'function') {
            cb(err, stdout, stderr);
        }
    });
}